unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, rkSmartPath, StdCtrls, ComCtrls, ExtCtrls;

type
  TfrmMain = class(TForm)
    pnlButtons: TPanel;
    sbMain: TStatusBar;
    pnlDummy: TPanel;
    btnNewFolder: TButton;
    btnAdd: TButton;
    memoDemo: TMemo;
    pbarMain: TrkSmartPath;
    chkOwnerDraw: TCheckBox;
    procedure btnAddClick(Sender: TObject);
    procedure btnNewFolderClick(Sender: TObject);
    procedure pbarMainPathChanged(Sender: TObject);
    procedure pbarMainClick(Sender: TObject);
    procedure pbarMainOwnerDraw(Sender: TObject; ACanvas: TCanvas; ARect: TRect;
      AText: string; AState: TspItemState; AButton: Boolean);
    procedure chkOwnerDrawClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

procedure TfrmMain.btnAddClick(Sender: TObject);
begin
  pbarMain.Favorites.Add(pbarMain.Path);
end;

procedure TfrmMain.btnNewFolderClick(Sender: TObject);
begin
  pbarMain.DoEdit(True);
end;

procedure TfrmMain.chkOwnerDrawClick(Sender: TObject);
begin
  if chkOwnerDraw.Checked then
    pbarMain.OnOwnerDraw:= pbarMainOwnerDraw
  else
    pbarMain.OnOwnerDraw:= nil;
end;

procedure TfrmMain.pbarMainClick(Sender: TObject);
begin
  pbarMain.Path:= pbarMain.PopupPath;
end;

procedure TfrmMain.pbarMainOwnerDraw(Sender: TObject; ACanvas: TCanvas;
  ARect: TRect; AText: string; AState: TspItemState; AButton: Boolean);
var
  bool: Boolean;
begin
  bool:= False;
  case AState of
    spNormal: begin
                ACanvas.Font.Color:= clGray;
                ACanvas.Pen.Color:= clGray;
                ACanvas.Font.Style:= [];
              end;
    spButtonPressed:
              begin
                ACanvas.Font.Color:= clBlack;
                ACanvas.Pen.Color:= clGray;
                ACanvas.Font.Style:= [fsUnderline];
                bool:= True;
                ARect.Left:= ARect.Left + 1;
                ARect.Top:= ARect.Top + 1;
                ARect.Right:= ARect.Right + 1;
                ARect.Bottom:= ARect.Bottom + 1;
              end;
    spArrowPressed:
              begin
                ACanvas.Font.Color:= clGray;
                ACanvas.Pen.Color:= clBlack;
                ACanvas.Font.Style:= [fsUnderline];
                bool:= True;
              end;
    spButtonHot:
              begin
                ACanvas.Font.Color:= clBlack;
                ACanvas.Font.Style:= [fsUnderline];
                ACanvas.Pen.Color:= clGray;
              end;
    spArrowHot:
              begin
                ACanvas.Font.Color:= clGray;
                ACanvas.Font.Style:= [fsUnderline];
                ACanvas.Pen.Color:= clBlack;
              end;
  end;
  if AButton then
    DrawText(ACanvas.Handle, PChar(AText), Length(AText), ARect,
      DT_CENTER or DT_VCENTER or DT_SINGLELINE)
  else
    if bool then
      PaintArrow(ACanvas, ARect.Left + 1, ARect.Top + 8, True)
    else
      PaintArrow(ACanvas, ARect.Left + 2, ARect.Top + 9, False);
end;

procedure TfrmMain.pbarMainPathChanged(Sender: TObject);
begin
  sbMain.Panels[0].Text:= pbarMain.Path;
end;

end.
